Create a new class extended from RowFilterBase. For example:
The next step is to override the onFilter(args) to provide the custom filter action. The args.action is one of the following FilterActionType enumerations:
filter
unfilter
Use it to check if the filter or unfilter action should be provided. For example:
You can use the filterButtonVisible method to control the display of the filter buttons.
var spreadNS = GC.Spread.Sheets;
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
};
function initSpread(spread) {
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 200);
sheet.setValue(1, 0, "Name");
sheet.setValue(1, 1, "Score");
var score = [
{ name: "Simon", score: 59 },
{ name: "Jack", score: 70 },
{ name: "Lily", score: 86 },
{ name: "Bob", score: 54 },
{ name: "Lucy", score: 84 },
{ name: "John", score: 99 }
];
for (var i = 0, len = score.length; i < len; i++) {
var student = score[i];
sheet.setValue(i + 2, 0, student.name);
sheet.setValue(i + 2, 1, student.score);
}
function SelectionFilter(range) {
spreadNS.Filter.RowFilterBase.call(this, range);
}
SelectionFilter.prototype = new spreadNS.Filter.RowFilterBase();
SelectionFilter.prototype.onFilter = function (args) {
var sheet = args.sheet, range = args.range,
filterRows = args.filteredRows,
action = args.action,
doFilter = action === spreadNS.Filter.FilterActionType.filter;
if (doFilter) {
if (range.col < 0) {
range.col = 0;
range.colCount = sheet.getColumnCount();
}
var activeCellSet;
for (var i = 0, len = filterRows.length; i < len; i++) {
var r = filterRows[i];
for (var c = range.col, len1 = range.col + range.colCount; c < len1; c++) {
if (!activeCellSet) {
activeCellSet = true;
sheet.setSelection(r, c, 1, 1);
} else {
sheet.addSelection(r, c, 1, 1);
}
}
}
sheet.setValue(9, 1, "Select the filtered items");
} else {
sheet.setSelection(0, 0, 1, 1);
sheet.setValue(9, 1, "No filtered items");
}
spread.focus();
};
var actionFilter = new SelectionFilter(new spreadNS.Range(2, 1, 6, 1));
sheet.rowFilter(actionFilter);
actionFilter.filterButtonVisible(false);
sheet.resumePaint();
document.getElementById("btnFilter").addEventListener('click',function () {
var sheet = spread.getActiveSheet(),
filter = sheet.rowFilter(),
value = parseInt(document.getElementById("filterValue").value, 10),
col = 1;
if (filter && !isNaN(value)) {
filter.removeFilterItems(col);
var condition = new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: value
});
filter.addFilterItem(col, condition);
filter.filter();
sheet.invalidateLayout();
sheet.repaint();
}
});
document.getElementById("btnClearFilter").addEventListener('click',function () {
var sheet = spread.getActiveSheet(),
filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
}
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
<label for="filterValue">Score less than:</label>
<input id="filterValue" placeholder="Input filter score value" type="text" value="60"/>
<input type="button" id="btnFilter" value="Apply filter" title="Filter score column with filter action." />
<input type="button" id="btnClearFilter" value="Clear filter" title="Clear score column' filter." />
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

Create a new class extended from RowFilterBase. For example:
The next step is to override the onFilter(args) to provide the custom filter action. The args.action is one of the following FilterActionType enumerations:
filter
unfilter
Use it to check if the filter or unfilter action should be provided. For example:
You can use the filterButtonVisible method to control the display of the filter buttons.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const spreadNS = GC.Spread.Sheets;
class SelectionFilter extends GC.Spread.Sheets.Filter.RowFilterBase {
constructor(range) {
super(range);
}
onFilter(args) {
var sheet = args.sheet, range = args.range,
filterRows = args.filteredRows,
action = args.action,
doFilter = action === spreadNS.Filter.FilterActionType.filter;
if (doFilter) {
if (range.col < 0) {
range.col = 0;
range.colCount = sheet.getColumnCount();
}
var activeCellSet;
for (var i = 0, len = filterRows.length; i < len; i++) {
var r = filterRows[i];
for (var c = range.col, len1 = range.col + range.colCount; c < len1; c++) {
if (!activeCellSet) {
activeCellSet = true;
sheet.setSelection(r, c, 1, 1);
} else {
sheet.addSelection(r, c, 1, 1);
}
}
}
sheet.setValue(9, 1, "Select the filtered items");
} else {
sheet.setSelection(0, 0, 1, 1);
sheet.setValue(9, 1, "No filtered items");
}
sheet.parent.focus();
}
}
export function AppFunc() {
let spread = null;
const initSpread = (currSpread) => {
spread = currSpread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 200);
sheet.setValue(1, 0, "Name");
sheet.setValue(1, 1, "Score");
var score = [
{ name: "Simon", score: 59 },
{ name: "Jack", score: 70 },
{ name: "Lily", score: 86 },
{ name: "Bob", score: 54 },
{ name: "Lucy", score: 84 },
{ name: "John", score: 99 }
];
for (var i = 0, len = score.length; i < len; i++) {
var student = score[i];
sheet.setValue(i + 2, 0, student.name);
sheet.setValue(i + 2, 1, student.score);
}
var actionFilter = new SelectionFilter(new spreadNS.Range(2, 1, 6, 1));
sheet.rowFilter(actionFilter);
actionFilter.filterButtonVisible(false);
sheet.resumePaint();
}
const applyFilter = () => {
var sheet = spread.getActiveSheet(),
filter = sheet.rowFilter(),
value = parseInt(document.getElementById("filterValue").value, 10),
col = 1;
if (filter && !isNaN(value)) {
filter.removeFilterItems(col);
var condition = new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: value
});
filter.addFilterItem(col, condition);
filter.filter();
sheet.invalidateLayout();
sheet.repaint();
}
}
const removeFilter = () => {
var sheet = spread.getActiveSheet(),
filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
}
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel applyFilter={(e) => { applyFilter(e) }} removeFilter={(e) => { removeFilter(e) }} />
</div>;
}
function Panel(props) {
return (
<div class="options-container">
<div class="option-row">
<label htmlFor="filterValue">Score less than:</label>
<input id="filterValue" placeholder="Input filter score value" type="text" defaultValue={60} />
<input type="button" id="btnFilter" value="Apply filter" title="Filter score column with filter action." onClick={(e) => { props.applyFilter(e) }} />
<input type="button" id="btnClearFilter" value="Clear filter" title="Clear score column' filter." onClick={(e) => { props.removeFilter(e) }} />
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const Component = React.Component;
const spreadNS = GC.Spread.Sheets;
class SelectionFilter extends GC.Spread.Sheets.Filter.RowFilterBase {
constructor(range) {
super(range);
}
onFilter(args) {
var sheet = args.sheet, range = args.range,
filterRows = args.filteredRows,
action = args.action,
doFilter = action === spreadNS.Filter.FilterActionType.filter;
if (doFilter) {
if (range.col < 0) {
range.col = 0;
range.colCount = sheet.getColumnCount();
}
var activeCellSet;
for (var i = 0, len = filterRows.length; i < len; i++) {
var r = filterRows[i];
for (var c = range.col, len1 = range.col + range.colCount; c < len1; c++) {
if (!activeCellSet) {
activeCellSet = true;
sheet.setSelection(r, c, 1, 1);
} else {
sheet.addSelection(r, c, 1, 1);
}
}
}
sheet.setValue(9, 1, "Select the filtered items");
} else {
sheet.setSelection(0, 0, 1, 1);
sheet.setValue(9, 1, "No filtered items");
}
sheet.parent.focus();
}
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel applyFilter={(e)=>{this.applyFilter(e)}} removeFilter={(e)=>{this.removeFilter(e)}} />
</div>;
}
initSpread(spread) {
this.spread = spread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 200);
sheet.setValue(1, 0, "Name");
sheet.setValue(1, 1, "Score");
var score = [
{ name: "Simon", score: 59 },
{ name: "Jack", score: 70 },
{ name: "Lily", score: 86 },
{ name: "Bob", score: 54 },
{ name: "Lucy", score: 84 },
{ name: "John", score: 99 }
];
for (var i = 0, len = score.length; i < len; i++) {
var student = score[i];
sheet.setValue(i + 2, 0, student.name);
sheet.setValue(i + 2, 1, student.score);
}
var actionFilter = new SelectionFilter(new spreadNS.Range(2, 1, 6, 1));
sheet.rowFilter(actionFilter);
actionFilter.filterButtonVisible(false);
sheet.resumePaint();
}
applyFilter () {
var sheet = this.spread.getActiveSheet(),
filter = sheet.rowFilter(),
value = parseInt(document.getElementById("filterValue").value, 10),
col = 1;
if (filter && !isNaN(value)) {
filter.removeFilterItems(col);
var condition = new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: value
});
filter.addFilterItem(col, condition);
filter.filter();
sheet.invalidateLayout();
sheet.repaint();
}
}
removeFilter () {
var sheet = this.spread.getActiveSheet(),
filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
}
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<div class="option-row">
<label htmlFor="filterValue">Score less than:</label>
<input id="filterValue" placeholder="Input filter score value" type="text" defaultValue={60}/>
<input type="button" id="btnFilter" value="Apply filter" title="Filter score column with filter action." onClick={(e)=>{this.props.applyFilter(e)}} />
<input type="button" id="btnClearFilter" value="Clear filter" title="Clear score column' filter." onClick={(e)=>{this.props.removeFilter(e)}} />
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Create a new class extended from RowFilterBase. For example:
The next step is to override the onFilter(args) to provide the custom filter action. The args.action is one of the following FilterActionType enumerations:
filter
unfilter
Use it to check if the filter or unfilter action should be provided. For example:
You can use the filterButtonVisible method to control the display of the filter buttons.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label for="filterValue">Score less than:</label>
<input id="filterValue" placeholder="Input filter score value" type="text" value="60" />
<input type="button" id="btnFilter" value="Apply filter" title="Filter score column with filter action."
@click="applyFilter($event)" />
<input type="button" id="btnClearFilter" value="Clear filter" title="Clear score column' filter."
@click="removeFilter($event)" />
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
let spreadRef;
const spreadNS = GC.Spread.Sheets;
const initSpread = (spread) => {
spreadRef = spread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 200);
sheet.setValue(1, 0, "Name");
sheet.setValue(1, 1, "Score");
var score = [
{ name: "Simon", score: 59 },
{ name: "Jack", score: 70 },
{ name: "Lily", score: 86 },
{ name: "Bob", score: 54 },
{ name: "Lucy", score: 84 },
{ name: "John", score: 99 }
];
for (var i = 0, len = score.length; i < len; i++) {
var student = score[i];
sheet.setValue(i + 2, 0, student.name);
sheet.setValue(i + 2, 1, student.score);
}
function SelectionFilter(range) {
spreadNS.Filter.RowFilterBase.call(this, range);
}
SelectionFilter.prototype = new spreadNS.Filter.RowFilterBase();
SelectionFilter.prototype.onFilter = function (args) {
var sheet = args.sheet, range = args.range,
filterRows = args.filteredRows,
action = args.action,
doFilter = action === spreadNS.Filter.FilterActionType.filter;
if (doFilter) {
if (range.col < 0) {
range.col = 0;
range.colCount = sheet.getColumnCount();
}
var activeCellSet;
for (var i = 0, len = filterRows.length; i < len; i++) {
var r = filterRows[i];
for (var c = range.col, len1 = range.col + range.colCount; c < len1; c++) {
if (!activeCellSet) {
activeCellSet = true;
sheet.setSelection(r, c, 1, 1);
} else {
sheet.addSelection(r, c, 1, 1);
}
}
}
sheet.setValue(9, 1, "Select the filtered items");
} else {
sheet.setSelection(0, 0, 1, 1);
sheet.setValue(9, 1, "No filtered items");
}
spread.focus();
};
var actionFilter = new SelectionFilter(new spreadNS.Range(2, 1, 6, 1));
sheet.rowFilter(actionFilter);
actionFilter.filterButtonVisible(false);
sheet.resumePaint();
};
const applyFilter = () => {
var sheet = spreadRef.getActiveSheet(),
filter = sheet.rowFilter(),
value = parseInt(document.getElementById("filterValue").value, 10),
col = 1;
if (filter && !isNaN(value)) {
filter.removeFilterItems(col);
var condition = new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: value
});
filter.addFilterItem(col, condition);
filter.filter();
sheet.invalidateLayout();
sheet.repaint();
}
};
const removeFilter = () => {
var sheet = spreadRef.getActiveSheet(),
filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
}
};
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Create a new class extended from RowFilterBase. For example:
The next step is to override the onFilter(args) to provide the custom filter action. The args.action is one of the following FilterActionType enumerations:
filter
unfilter
Use it to check if the filter or unfilter action should be provided. For example:
You can use the filterButtonVisible method to control the display of the filter buttons.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets;
class SelectionFilter extends GC.Spread.Sheets.Filter.RowFilterBase {
constructor(range: any) {
super(range);
}
onFilter(args: any) {
let sheet = args.sheet, range = args.range,
filterRows = args.filteredRows,
action = args.action,
doFilter = action === spreadNS.Filter.FilterActionType.filter;
if (doFilter) {
if (range.col < 0) {
range.col = 0;
range.colCount = sheet.getColumnCount();
}
let activeCellSet;
for (let i = 0, len = filterRows.length; i < len; i++) {
let r = filterRows[i];
for (let c = range.col, len1 = range.col + range.colCount; c < len1; c++) {
if (!activeCellSet) {
activeCellSet = true;
sheet.setSelection(r, c, 1, 1);
} else {
sheet.addSelection(r, c, 1, 1);
}
}
}
sheet.setValue(9, 1, "Select the filtered items");
} else {
sheet.setSelection(0, 0, 1, 1);
sheet.setValue(9, 1, "No filtered items");
}
sheet.parent.focus();
}
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
factorial: any;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 200);
sheet.setValue(1, 0, "Name");
sheet.setValue(1, 1, "Score");
const score = [
{ name: "Simon", score: 59 },
{ name: "Jack", score: 70 },
{ name: "Lily", score: 86 },
{ name: "Bob", score: 54 },
{ name: "Lucy", score: 84 },
{ name: "John", score: 99 }
];
for (let i = 0, len = score.length; i < len; i++) {
let student = score[i];
sheet.setValue(i + 2, 0, student.name);
sheet.setValue(i + 2, 1, student.score);
}
let actionFilter = new SelectionFilter(new spreadNS.Range(2, 1, 6, 1));
sheet.rowFilter(actionFilter);
actionFilter.filterButtonVisible(false);
sheet.resumePaint();
}
applyFilter () {
let sheet = this.spread.getActiveSheet(),
filter = sheet.rowFilter(),
value = parseInt((document.getElementById("filterValue") as HTMLInputElement).value, 10),
col = 1;
if (filter && !isNaN(value)) {
filter.removeFilterItems(col);
let condition = new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: value
});
filter.addFilterItem(col, condition);
filter.filter();
sheet.invalidateLayout();
sheet.repaint();
}
}
removeFilter () {
let sheet = this.spread.getActiveSheet(),
filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label for="filterValue">Score less than:</label>
<input id="filterValue" placeholder="Input filter score value" type="text" value="60"/>
<input type="button" id="btnFilter" value="Apply filter" title="Filter score column with filter action." (click)="applyFilter($event)" />
<input type="button" id="btnClearFilter" value="Clear filter" title="Clear score column' filter." (click)="removeFilter($event)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);